Bullet Collision Detection & Physics Library: btSoftBodyHelpers Struct Reference

Bullet Collision Detection & Physics Library

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Static Public Member Functions | List of all members
btSoftBodyHelpers Struct Reference

`#include <btSoftBodyHelpers.h>`

## Static Public Member Functions
static void | Draw (btSoftBody *psb, btIDebugDraw *idraw, int drawflags=fDrawFlags::Std)
static void | DrawInfos (btSoftBody *psb, btIDebugDraw *idraw, bool masses, bool areas, bool stress)
static void | DrawNodeTree (btSoftBody *psb, btIDebugDraw *idraw, int mindepth=0, int maxdepth=-1)
static void | DrawFaceTree (btSoftBody *psb, btIDebugDraw *idraw, int mindepth=0, int maxdepth=-1)
static void | DrawClusterTree (btSoftBody *psb, btIDebugDraw *idraw, int mindepth=0, int maxdepth=-1)
static void | DrawFrame (btSoftBody *psb, btIDebugDraw *idraw)
static btSoftBody * | CreateRope (btSoftBodyWorldInfo &worldInfo, const btVector3 &from, const btVector3 &to, int res, int fixeds)
static btSoftBody * | CreatePatch (btSoftBodyWorldInfo &worldInfo, const btVector3 &corner00, const btVector3 &corner10, const btVector3 &corner01, const btVector3 &corner11, int resx, int resy, int fixeds, bool gendiags, btScalar perturbation=0.)
static btSoftBody * | CreatePatchUV (btSoftBodyWorldInfo &worldInfo, const btVector3 &corner00, const btVector3 &corner10, const btVector3 &corner01, const btVector3 &corner11, int resx, int resy, int fixeds, bool gendiags, float *tex_coords=0)
static float | CalculateUV (int resx, int resy, int ix, int iy, int id)
static btSoftBody * | CreateEllipsoid (btSoftBodyWorldInfo &worldInfo, const btVector3 &center, const btVector3 &radius, int res)
static btSoftBody * | CreateFromTriMesh (btSoftBodyWorldInfo &worldInfo, const btScalar *vertices, const int *triangles, int ntriangles, bool randomizeConstraints=true)
static btSoftBody * | CreateFromConvexHull (btSoftBodyWorldInfo &worldInfo, const btVector3 *vertices, int nvertices, bool randomizeConstraints=true)
static btSoftBody * | CreateFromTetGenData (btSoftBodyWorldInfo &worldInfo, const char *ele, const char *face, const char *node, bool bfacelinks, bool btetralinks, bool bfacesfromtetras)
static btSoftBody * | CreateFromVtkFile (btSoftBodyWorldInfo &worldInfo, const char *vtk_file)
static void | writeObj (const char *file, const btSoftBody *psb)
static void | writeState (const char *file, const btSoftBody *psb)
static void | getBarycentricWeights (const btVector3 &a, const btVector3 &b, const btVector3 &c, const btVector3 &d, const btVector3 &p, btVector4 &bary)
static void | getBarycentricWeights (const btVector3 &a, const btVector3 &b, const btVector3 &c, const btVector3 &p, btVector4 &bary)
static void | interpolateBarycentricWeights (btSoftBody *psb)
static void | extrapolateBarycentricWeights (btSoftBody *psb)
static void | generateBoundaryFaces (btSoftBody *psb)
static void | duplicateFaces (const char *filename, const btSoftBody *psb)
static void | ReoptimizeLinkOrder (btSoftBody *psb)
| Sort the list of links to move link calculations that are dependent upon earlier ones as far as possible away from the calculation of those values This tends to make adjacent loop iterations not dependent upon one another, so out-of-order processors can execute instructions from multiple iterations at once.

## Detailed Description

Definition at line 50 of file btSoftBodyHelpers.h.

## Member Function Documentation

## ◆ CalculateUV()

float btSoftBodyHelpers::CalculateUV | ( | int | resx,
|  | int | resy,
|  | int | ix,
|  | int | iy,
|  | int | id )
| static

Definition at line 969 of file btSoftBodyHelpers.cpp.

## ◆ CreateEllipsoid()

btSoftBody * btSoftBodyHelpers::CreateEllipsoid | ( | btSoftBodyWorldInfo & | worldInfo,
|  | const btVector3 & | center,
|  | const btVector3 & | radius,
|  | int | res )
| static

Definition at line 1016 of file btSoftBodyHelpers.cpp.

## ◆ CreateFromConvexHull()

btSoftBody * btSoftBodyHelpers::CreateFromConvexHull | ( | btSoftBodyWorldInfo & | worldInfo,
|  | const btVector3 * | vertices,
|  | int | nvertices,
|  | bool | randomizeConstraints = true )
| static

Definition at line 1094 of file btSoftBodyHelpers.cpp.

## ◆ CreateFromTetGenData()

btSoftBody * btSoftBodyHelpers::CreateFromTetGenData | ( | btSoftBodyWorldInfo & | worldInfo,
|  | const char * | ele,
|  | const char * | face,
|  | const char * | node,
|  | bool | bfacelinks,
|  | bool | btetralinks,
|  | bool | bfacesfromtetras )
| static

Definition at line 1141 of file btSoftBodyHelpers.cpp.

## ◆ CreateFromTriMesh()

btSoftBody * btSoftBodyHelpers::CreateFromTriMesh | ( | btSoftBodyWorldInfo & | worldInfo,
|  | const btScalar * | vertices,
|  | const int * | triangles,
|  | int | ntriangles,
|  | bool | randomizeConstraints = true )
| static

Definition at line 1047 of file btSoftBodyHelpers.cpp.

## ◆ CreateFromVtkFile()

btSoftBody * btSoftBodyHelpers::CreateFromVtkFile | ( | btSoftBodyWorldInfo & | worldInfo,
|  | const char * | vtk_file )
| static

Definition at line 1247 of file btSoftBodyHelpers.cpp.

## ◆ CreatePatch()

btSoftBody * btSoftBodyHelpers::CreatePatch | ( | btSoftBodyWorldInfo & | worldInfo,
|  | const btVector3 & | corner00,
|  | const btVector3 & | corner10,
|  | const btVector3 & | corner01,
|  | const btVector3 & | corner11,
|  | int | resx,
|  | int | resy,
|  | int | fixeds,
|  | bool | gendiags,
|  | btScalar | perturbation = 0. )
| static

Definition at line 723 of file btSoftBodyHelpers.cpp.

## ◆ CreatePatchUV()

btSoftBody * btSoftBodyHelpers::CreatePatchUV | ( | btSoftBodyWorldInfo & | worldInfo,
|  | const btVector3 & | corner00,
|  | const btVector3 & | corner10,
|  | const btVector3 & | corner01,
|  | const btVector3 & | corner11,
|  | int | resx,
|  | int | resy,
|  | int | fixeds,
|  | bool | gendiags,
|  | float * | tex_coords = 0 )
| static

Definition at line 807 of file btSoftBodyHelpers.cpp.

## ◆ CreateRope()

btSoftBody * btSoftBodyHelpers::CreateRope | ( | btSoftBodyWorldInfo & | worldInfo,
|  | const btVector3 & | from,
|  | const btVector3 & | to,
|  | int | res,
|  | int | fixeds )
| static

Definition at line 691 of file btSoftBodyHelpers.cpp.

## ◆ Draw()

void btSoftBodyHelpers::Draw | ( | btSoftBody * | psb,
|  | btIDebugDraw * | idraw,
|  | int | drawflags = fDrawFlags::Std )
| static

Definition at line 172 of file btSoftBodyHelpers.cpp.

## ◆ DrawClusterTree()

void btSoftBodyHelpers::DrawClusterTree | ( | btSoftBody * | psb,
|  | btIDebugDraw * | idraw,
|  | int | mindepth = 0,
|  | int | maxdepth = -1 )
| static

Definition at line 484 of file btSoftBodyHelpers.cpp.

## ◆ DrawFaceTree()

void btSoftBodyHelpers::DrawFaceTree | ( | btSoftBody * | psb,
|  | btIDebugDraw * | idraw,
|  | int | mindepth = 0,
|  | int | maxdepth = -1 )
| static

Definition at line 475 of file btSoftBodyHelpers.cpp.

## ◆ DrawFrame()

void btSoftBodyHelpers::DrawFrame | ( | btSoftBody * | psb,
|  | btIDebugDraw * | idraw )
| static

Definition at line 667 of file btSoftBodyHelpers.cpp.

## ◆ DrawInfos()

void btSoftBodyHelpers::DrawInfos | ( | btSoftBody * | psb,
|  | btIDebugDraw * | idraw,
|  | bool | masses,
|  | bool | areas,
|  | bool | stress )
| static

Definition at line 440 of file btSoftBodyHelpers.cpp.

## ◆ DrawNodeTree()

void btSoftBodyHelpers::DrawNodeTree | ( | btSoftBody * | psb,
|  | btIDebugDraw * | idraw,
|  | int | mindepth = 0,
|  | int | maxdepth = -1 )
| static

Definition at line 466 of file btSoftBodyHelpers.cpp.

## ◆ duplicateFaces()

void btSoftBodyHelpers::duplicateFaces | ( | const char * | filename,
|  | const btSoftBody * | psb )
| static

Definition at line 1522 of file btSoftBodyHelpers.cpp.

## ◆ extrapolateBarycentricWeights()

void btSoftBodyHelpers::extrapolateBarycentricWeights | ( | btSoftBody * | psb | ) |
| static

Definition at line 1647 of file btSoftBodyHelpers.cpp.

## ◆ generateBoundaryFaces()

void btSoftBodyHelpers::generateBoundaryFaces | ( | btSoftBody * | psb | ) |
| static

Definition at line 1354 of file btSoftBodyHelpers.cpp.

## ◆ getBarycentricWeights() [1/2]

void btSoftBodyHelpers::getBarycentricWeights | ( | const btVector3 & | a,
|  | const btVector3 & | b,
|  | const btVector3 & | c,
|  | const btVector3 & | d,
|  | const btVector3 & | p,
|  | btVector4 & | bary )
| static

Definition at line 1566 of file btSoftBodyHelpers.cpp.

## ◆ getBarycentricWeights() [2/2]

void btSoftBodyHelpers::getBarycentricWeights | ( | const btVector3 & | a,
|  | const btVector3 & | b,
|  | const btVector3 & | c,
|  | const btVector3 & | p,
|  | btVector4 & | bary )
| static

Definition at line 1586 of file btSoftBodyHelpers.cpp.

## ◆ interpolateBarycentricWeights()

void btSoftBodyHelpers::interpolateBarycentricWeights | ( | btSoftBody * | psb | ) |
| static

Definition at line 1603 of file btSoftBodyHelpers.cpp.

## ◆ ReoptimizeLinkOrder()

void btSoftBodyHelpers::ReoptimizeLinkOrder | ( | btSoftBody * | psb | ) |
| static

Sort the list of links to move link calculations that are dependent upon earlier ones as far as possible away from the calculation of those values This tends to make adjacent loop iterations not dependent upon one another, so out-of-order processors can execute instructions from multiple iterations at once.

Definition at line 543 of file btSoftBodyHelpers.cpp.

## ◆ writeObj()

void btSoftBodyHelpers::writeObj | ( | const char * | file,
|  | const btSoftBody * | psb )
| static

Definition at line 1426 of file btSoftBodyHelpers.cpp.

## ◆ writeState()

void btSoftBodyHelpers::writeState | ( | const char * | file,
|  | const btSoftBody * | psb )
| static

Definition at line 1492 of file btSoftBodyHelpers.cpp.

The documentation for this struct was generated from the following files:

- btSoftBodyHelpers.h
- btSoftBodyHelpers.cpp